//+----------------------------------------------------------------------------+
//| i-Sessions.mq4 |
//| |
//|   . aka KimIV |
//| http://www.kimiv.ru |
//| |
//| 16.11.2005   . |
//| 04.06.2008       . |
//| 25.10.2008  : Style -     |
//| FillBack -  . |
//+----------------------------------------------------------------------------+
#property copyright "  . aka KimIV"
#property link "http://www.kimiv.ru"

#property indicator_chart_window

//-------    ----------------------------------------+
extern int NumberOfDays = 30; //  
extern string AsiaBegin = "06:00"; //   
extern string AsiaEnd = "13:00"; //   
extern color AsiaColor = Ivory; //   
extern int Style = 2; //   
extern bool FillBack = True; //  

//------------------------------------------------
extern int BBars=0;
extern int TOS=6;
extern color ColorTOS=Black;
extern int TCS=13;
extern color ColorTCS=Black;
// Yellow Red Lime RoyalBlue Black
extern string TL="TL";

//+----------------------------------------------------------------------------+
//| Custom indicator initialization function |
//+----------------------------------------------------------------------------+
void init()
{
  DeleteObjects();
  for (int i=0; i<NumberOfDays; i++)
  {
    CreateObjects("AS"+i, AsiaColor);
  }
  Comment("");
}

//+----------------------------------------------------------------------------+
//| Custor indicator deinitialization function |
//+----------------------------------------------------------------------------+
void deinit() 
{
  DeleteObjects();
  ObjectsDeleteAll();
  Comment("");
}

//+----------------------------------------------------------------------------+
//|    |
//| : |
//| no -   |
//| cl -   |
//+----------------------------------------------------------------------------+
void CreateObjects(string no, color cl) 
{
  ObjectCreate(no, OBJ_RECTANGLE, 0, 0,0, 0,0);
  ObjectSet(no, OBJPROP_STYLE, Style);
  ObjectSet(no, OBJPROP_COLOR, cl);
  ObjectSet(no, OBJPROP_BACK, FillBack);
}

//+----------------------------------------------------------------------------+
//|    |
//+----------------------------------------------------------------------------+
void DeleteObjects() 
{
  for (int i=0; i<NumberOfDays; i++) 
  {
    ObjectDelete("AS"+i);
  }
  ObjectDelete("ASup");
  ObjectDelete("ASdn");
}

//+----------------------------------------------------------------------------+
//| Custom indicator iteration function |
//+----------------------------------------------------------------------------+
void start() 
{
  datetime dt=CurTime();
  int i=0;
  for ( i=0; i<NumberOfDays; i++)
  {
    DrawObjects(dt, "AS"+i, AsiaBegin, AsiaEnd);
    dt-=24*60*60;
    while (TimeDayOfWeek(dt)<1 || TimeDayOfWeek(dt)>5) dt-=24*60*60;
  }
  
  if(BBars<=0)BBars=Bars;
  for( i=0;i<BBars;i++)
  {
    Time_V_Line( TOS, i, ColorTOS);
    Time_V_Line( TCS, i, ColorTCS);
    
  }
}

void Time_V_Line( int TIME, int Sdvig, color COLOR)
{
  //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  if(TimeHour( Time[Sdvig])==TIME &&
      TimeMinute( Time[Sdvig])==0
      )
  {
    string sTL=TL+TIME+" "+Sdvig;
    ObjectCreate(sTL, OBJ_VLINE, 0, Time[Sdvig], 0);
    ObjectSet( sTL, OBJPROP_COLOR, COLOR);
    WindowRedraw();
  }
  return;
}//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//+----------------------------------------------------------------------------+
//|     |
//| : |
//| dt -    |
//| no -   |
//| tb -    |
//| te -    |
//+----------------------------------------------------------------------------+
void DrawObjects(datetime dt, string no, string tb, string te) 
{
  datetime t1, t2;
  double p1, p2;
  int b1, b2;
  
  t1=StrToTime(TimeToStr(dt, TIME_DATE)+" "+tb);
  t2=StrToTime(TimeToStr(dt, TIME_DATE)+" "+te);
  b1=iBarShift(NULL, 0, t1);
  b2=iBarShift(NULL, 0, t2);
  p1=High[Highest(NULL, 0, MODE_HIGH, b1-b2+1, b2)];
  p2=Low [Lowest (NULL, 0, MODE_LOW , b1-b2+1, b2)];
  ObjectSet(no, OBJPROP_TIME1 , t1);
  ObjectSet(no, OBJPROP_PRICE1, p1+500);
  ObjectSet(no, OBJPROP_TIME2 , t2);
  ObjectSet(no, OBJPROP_PRICE2, p2-500);
}

//+----------------------------------------------------------------------------+
